/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Full-screen editor                                                     *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

/* Yeah yeah, I *know* that cursor_x and cursor_y are reversed.  But I did  *
 * my first non-TTY programming on an Apple ][.  Force of habit, OK?!! :-)  */

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <mem.h>
#include <setjmp.h>
#include <string.h>
#include <assert.h>
#include "prog.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

struct _msg *mmsg;

int cursor_x,
    cursor_y,
    offset,
    usrlen,
    num_quotebuf,
    cur_quotebuf,
    last_quote,
    quotefile=-1;

char *update_table,
     *quotebuf,
     last_msg_attr,
     insert,
     initials[10],
     pos_to_be_updated,
     skip_update,
     quoting;

long *quote_pos;

#ifdef OS_2
void Vidfcur(void);
#endif

static void pascal Do_Update(void);



int pascal MagnEt(struct _msg *msg,int msgfile)
{
#ifdef FREE_IN_EDITOR
  long last_cl;
#endif

  long now_cl;

  int ret,
      lastch,
      ch,
      state,
      timer2,
      x;

  char break_loop;

  quoting=FALSE;
  quotefile=-1;
  lastch=-1;
  mmsg=msg;
  state=0;

  if ((update_table=malloc(UPDATEBUF_LEN))==NULL)
    return ABORT;

  if ((quotebuf=malloc(QUOTELINES*MAX_LINELEN))==NULL)
  {
    free(update_table);
    return ABORT;
  }

  if ((quote_pos=malloc(MAX_QUOTEBUF*sizeof(long)))==NULL)
  {
    free(update_table);
    free(quotebuf);
    return ABORT;
  }

#ifdef FREE_IN_EDITOR
  if (msgs)
  {
    last_cl=(long)coreleft();
    free(msgs);
    msgs=NULL;
  }
  else last_cl=0L;

  /* Set the maximum number of lines in the message to the highest the     *
   * user will ever be able to send, or to the approximate number          *
   * which can fit in available memory, whichever is lower.                */
#endif

  now_cl=coreleft();

#ifdef FREE_IN_EDITOR
  if (last_cl==now_cl && last_cl)  /* If it didn't change... */
  {
    /* ... then assume that msgs[] was buried between two other memory     *
     *     blocks, and hence won't change memory count.  Therefore, we     *
     *     should bump it up ourselves...                                  */

    now_cl += sizeof(int)*MAX_MSG;
  }
#endif

  max_lines=(int)min((long)MAX_LINES,(now_cl-MAXED_SAVE_MEM)/(LINELEN*2L));

  if (max_lines==0)   /* Something's really wrong here! */
  {
    logit(mem_nmsgb);
    Puts(mem_nmsgb);

    Press_ENTER();
  }
  else                /* Things look A-OK! */
  {
    /* Allocate the last line, for our spiffy '-end-' widget. */
    if (Allocate_Line(max_lines))
      EdMemOvfl();

    /* Turn off modem flow controls, so we can interpret characters such  *
     * as control-C, control-S, etc.                                      */

    (void)mdm_ctrlc(0);
    Mdm_Flow_Off();

    update_table[max_lines]=TRUE;

    Init_Vars();

    if (usr.formfeed)
      Puts(CLS);
    else NoFF_CLS();

    if (Allocate_Line(offset+1))
      EdMemOvfl();

    break_loop=FALSE;

    if (msgfile != -1)
    {
      Load_Message(msgfile);
      Redraw_Text();
      Do_Update();
    }

    MagnEt_Intro();

    if (setjmp(jumpto)==0) /* Really ugly, but the best way to handle errs */
    {
      while (1)
      {
        /* This loop is to update lines on the screen.  If the user wants  *
         * to do a few page-down's in a row or something, we don't want to *
         * do a FULL page-down if there is another character waiting,      *
         * which usually means the user wants something NOW.               */

        while (!break_loop)
        {
          screen[max_lines][0]=SOFT_CR;
          screen[max_lines][1]='\0';

          /* So we'll display the -end- whenever we get a chance.  Since   *
           * we don't want the '-end' continiously displaying, we only set *
           * the update table to restore the line if it isn't on-screen,   *
           * so it DOES get displayed once we DO come back on-screen.      *
           * (Confused yet?)                                               */

          if (! (offset+cursor_x >= max_lines-usrlen))
            update_table[max_lines]=TRUE;

          /* Stick the cursor in the right spot */
          if (!Mdm_keyp() && pos_to_be_updated)
            Update_Position();

          vbuf_flush();

          Do_Update();

          /* Convert any local ^Cs or ^breaks to ASCII 3, which is what we *
             want.                                                         */

          timer2=FALSE;
          input_timeout=timerset(TIMEOUT*100);

          while (! Mdm_keyp() && !brk_trapped)
          {
            Check_Time_Limit(&input_timeout,&timer2);
            Giveaway_Slice();
          }

          if (brk_trapped)
          {
            ch='\x03';
            brk_trapped--;
          }
          else ch=Mdm_getcw();

          switch (ch)
          {
            case '\x00':    /* Scan key! */
              switch (Process_Scan_Code())
              {
                case SAVE:
                  ret=SAVE;
                  goto BackToCaller;

                case ABORT:
                  break_loop=TRUE;
                  break;
              }
              break;

            case '\x01':    /* Control-A */
              Word_Left();
              break;

            case '\x03':    /* Control-C */
              Page_Down();
              break;

            case '\x04':    /* Control-D */
              Cursor_Right();
              break;

            case '\x05':    /* Control-E */
              Cursor_Up();
              break;

            case '\x06':    /* Control-F */
              Word_Right();
              break;

            case '\x07':    /* Delete character */
              Delete_Char();
              break;

            case '\x08':    /* Backspace */
            case '\x7f':
              BackSpace();
              break;

            case '\x09':    /* Tab */
              skip_update=TRUE;

              for (x=0;x < 8;x++)
              {
                if (insert)
                  Add_Character(' ');
                else Cursor_Right();
              }

              skip_update=FALSE;
              break;

            case '\x0b':    /* Control-K */
              switch (Process_Control_K())
              {
                case SAVE:
                  ret=SAVE;
                  goto BackToCaller;

                case ABORT:
                  break_loop=TRUE;
                  break;
              }
              break;

            case '\x0c':    /* Control-W, redraw current line only */
              update_table[offset+cursor_x]=TRUE;
              break;

            case '\x0d':    /* Return */
              Carriage_Return(TRUE);
              break;

            case '\x0e':     /* Control-N, same as message enter screen, for help */
            case '\x0f':     /* Control-O */
              MagnEt_Help();
              break;

            case '\x11':    /* Control-Q */
              Process_Control_Q();
              break;

            case '\x12':    /* Control-R */
              Page_Up();
              break;

            case '\x13':    /* Control-S */
              Cursor_Left();
              break;

#if 0
            case '\x14':    /* Control-T */
              Delete_Word(); 
              break;
#endif

            case '\x16':    /* Control-V */
              Toggle_Insert();
              break;

            case '\x17':    /* Control-W, redraw entire screen */
              Redraw_Text();
              Redraw_StatusLine();
              Redraw_Quote();
              break;

            case '\x18':    /* Control-X */
              Cursor_Down(TRUE);
              break;

            case '\x19':    /* Control-Y */
              if (lastch != '\x19')
              {
                x=cursor_x;

                Delete_Line(cursor_x);
                cursor_y=1;

                Goto(cursor_x,cursor_y);

                if (x==cursor_x)  /* We weren't on last line */
                  ch='\x00';
              }
              break;

            case '\x1a':    /* Control-Z */
              ret=SAVE;
              goto BackToCaller;

            case '\x1b':    /* ESC */
              if (Process_Cursor_Key()==ABORT)
                break_loop=TRUE;
              break;

            case '\x02':
            case '\x0a':
            case '\x10':
            case '\x14':
            case '\x15':
            case '\x1c':
            case '\x1d':
            case '\x1e':
            case '\x1f':
              MagnEt_Bad_Keystroke();
              break;

            case '+':
              Puts(sp_bs);
              /* fall-through */

            default:        /* Normal character */
              {
                if (state==0 && (ch==':' || ch==';' || ch=='B' || ch=='8'))
                  state=1;
                else if (state==1 && ch=='-')
                  state=2;
                else if (state==2 && (ch=='(' || ch=='{' || ch=='['))
                {
                  Goto(usrlen,10);

                  /* Tell this deadbeat to lighten up! */
                  Puts(s(happy));

                  Goto(cursor_x,cursor_y);
                  state=0;
                }
                else state=0;

                if (ch > 31 && (ch < 127 || Highbit_Allowed()))
                  Add_Character(ch);
              }

              break;
          }

          lastch=ch;
        }

        if (usr.help != HOTFLASH)
          Puts("\n" CLEOL);

        WhiteN();

        /* Make sure s/he really means it */
        if (GetyNAnswer(abortmsg,0)==YES)
          break;  /* Get out of loop */
        else
        {
          (void)mdm_ctrlc(0);
          Mdm_Flow_Off();

          Redraw_Text();
          Redraw_StatusLine();
          Redraw_Quote();

          break_loop=FALSE; /* Keep on truckin' */
        }
      }   /* while (1) */
    }     /* if (setjmp()==0) */
  }       /* max_lines != 0 */


 /* Free everything, then return an ABORT code, since we only get this far *
  * if something craps out.                                                */

  Free_All();

  if (usr.formfeed)
    Puts(CLS);
  else NoFF_CLS();

  ret=ABORT;

BackToCaller:

  Mdm_Flow_On();

  if (quoting)
    close(quotefile);

  free(update_table);
  free(quotebuf);
  free(quote_pos);

#ifdef FREE_IN_EDITOR
  if (msgs==NULL)
  {
    /* Only re-scan if we aren't saving, since saving causes a rescan anyway */

    if ((msgs=(int *)malloc(sizeof(int)*MAX_MSG)) != NULL && ret != SAVE)
      Scan_Msg_Numbers(FALSE);
  }
#endif

  return ret;
}


int pascal Process_Scan_Code(void)
{
  if (fossil_peek()=='\x24')    /* Alt-J */
  {
    pgetch();
    Shell_To_Dos();
    Fix_MagnEt();
  }
  else switch(Mdm_getcw())
  {
    case 59:
      MagnEt_Help();
      break;

    case 16:      /* Quote */
      Quote_OnOff();
      break;

    case 31:      /* Exit/Save */
      return SAVE;

    case 45:      /* Exit/NoSave */
      return ABORT;

    case 46:      /* Quote copy */
      if (quoting)
        Quote_Copy();
      break;

     case 68:
      MagnEt_Menu();
      break;

    case 71:
      Cursor_BeginLine();
      break;

    case 72:
      Cursor_Up();
      break;

    case 73:
      Page_Up();
      break;

    case 75:
      Cursor_Left();
      break;

    case 77:
      Cursor_Right();
      break;

    case 79:
      Cursor_EndLine();
      break;

    case 80:
      Cursor_Down(TRUE);
      break;

    case 81:
      Page_Down();
      break;

    case 82:
      Toggle_Insert();
      break;

    case 83:
      Delete_Char();
      break;

    case 115:
      Word_Left();
      break;

    case 116:
      Word_Right();
      break;

    default:
      MagnEt_Bad_Keystroke();
      break;
  }

  return NOTHING;
}



int pascal Process_Cursor_Key(void)
{
  switch(Mdm_getcw())
  {
    case '\x1b':      /* Abort message */
      return ABORT;

    case '[':         /* Start of ANSI sequence */
    case 'O':
      switch (Mdm_getcw())
      {
        case 'A':     /* Cursor Up */
          Cursor_Up();
          break;

        case 'B':     /* Cursor Down */
          Cursor_Down(TRUE);
          break;

        case 'C':     /* Cursor Right */
          Cursor_Right();
          break;

        case 'D':     /* Cursor Left */
          Cursor_Left();
          break;

        case 'H':     /* Home */
          Cursor_BeginLine();
          break;
          
        case 'K':     /* End */
          Cursor_EndLine();
          break;

        default:
          MagnEt_Bad_Keystroke();
          break;

      }
      break;

    default:
      MagnEt_Bad_Keystroke();
      break;
  }

  return NOTHING;
}


void pascal Process_Control_Q(void)
{
  int ch;

  Goto(usrlen,usrwidth-3);
  Puts(YELONBLUE "^Q");
  Goto(cursor_x,cursor_y);
  Printf(attr_string,DEFAULT_ATTR);

  ch=Mdm_getcw();

  switch(toupper(ch))
  {
    case 0:         /* Scan code... */
      Mdm_getcw();  /* Throw it away */
      break;

    case 19:
    case 'S':       /* Beginning of line */
      Cursor_BeginLine();
      break;

    case 4:
    case 'D':       /* End of line */
      Cursor_EndLine();
      break;

    case 25:
    case 'Y':       /* End of line */
      Puts(CLEOL);
      screen[offset+cursor_x][cursor_y]='\0';
      break;

    default:
      MagnEt_Bad_Keystroke();
      break;
  }

  Goto(usrlen,usrwidth-3);
  Puts(YELONBLUE "  ");
  Goto(cursor_x,cursor_y);
  Printf(attr_string,DEFAULT_ATTR);
}


int pascal Process_Control_K(void)
{
  int ret,
      ch;

  Goto(usrlen,usrwidth-3);
  Puts(YELONBLUE "^K");
  Goto(cursor_x,cursor_y);
  Printf(attr_string,DEFAULT_ATTR);

  ret=NOTHING;

  while (!Mdm_keyp() && !brk_trapped)
    Giveaway_Slice();

  if (brk_trapped)
  {
    brk_trapped=0;
    ch=3;
  }
  else ch=Mdm_getcw();

  switch(toupper(ch))
  {
    case 0:         /* Scan code... */
      Mdm_getcw();  /* Throw it away */
      break;

    case 4:
    case 19:
    case 'D':     /* Exit/Save */
    case 'S':
      ret=SAVE;
      break;

    case '?':
      MagnEt_Help();
      break;

    case 8:
    case 'H':
      MagnEt_Menu();
      break;

    case 16:
    case 'P':
      Piggy();
      break;

    case 18:
    case 'R':
      Quote_OnOff();
      break;

    case 3:
    case 'C':
      if (quoting)
        Quote_Copy();
      break;


    case 17:
    case 'Q':     /* Exit/NoSave */
      ret=ABORT;
      break;

    default:
      MagnEt_Bad_Keystroke();
  }

  Goto(usrlen,usrwidth-3);
  Puts(YELONBLUE "  ");
  Goto(cursor_x,cursor_y);
  Printf(attr_string,DEFAULT_ATTR);

  return ret;
}



void pascal Redraw_Text(void)
{
  int x;

  /* Make the entire refresh buffer "dirty" */
  
  Printf(attr_string,DEFAULT_ATTR);

  if (update_table)
    for (x=0;x < UPDATEBUF_LEN;x++)
      update_table[x]=TRUE;
}



void pascal Redraw_StatusLine(void)
{
  Goto(usrlen,1);

  Printf(s(max_status),
         mmsg->to,
         !strnicmp(mmsg->subj,"Re:",3) ? &mmsg->subj[4] : mmsg->subj);

  if (insert)
  {
    Goto(usrlen,usrwidth-13);

    Puts(status_insert);
  }

  Update_Position();

  Puts(CLEOL);
  Printf(attr_string,DEFAULT_ATTR);

  Goto(cursor_x,cursor_y);
}


void pascal Redraw_Quote(void)
{
  int temp;

  if (quoting)
  {
    Goto(usrlen+1,usrwidth-12);

    for (temp=0;temp < QUOTELINES;temp++)
      Printf(quote_format,usrlen+1+temp,initials,quotebuf+(temp*MAX_LINELEN));

    Puts(CLEOL);
  }

  Printf(attr_string,DEFAULT_ATTR);

  Goto(cursor_x,cursor_y);
}


void pascal BackSpace(void)
{
  int strlc,cx,cy;

  if (cursor_y-1 > strlen(screen[offset+cursor_x]+1) && cursor_y > 1)
    Cursor_Left();
  else
  {
    if (cursor_y > 1)
    {
      memmove(screen[offset+cursor_x]+cursor_y-1,screen[offset+cursor_x]+cursor_y,
              strlen(screen[offset+cursor_x]+cursor_y)+1);

      Putc('\x08');

      Update_Line(offset+cursor_x,--cursor_y,0,TRUE);
    }
    else    /* If at beginning of line */
    {
      if (offset+cursor_x != 1)
      {
        if (cursor_x==1 && offset != 0)
          Scroll_Up(SCROLL_CASUAL,cursor_x+SCROLL_CASUAL);

        strlc=strlen(screen[offset+cursor_x-1]+1)+1;

        memmove(screen[offset+cursor_x-1]+strlen(screen[offset+cursor_x-1]+1)+1,
                screen[offset+cursor_x]+1,strlen(screen[offset+cursor_x]+1)+1);

        cx=cursor_x;

        Update_Line(offset+cursor_x-(offset+cx != 1 ? 1 : 0),cursor_y=strlc,0,FALSE);

        cy=cursor_y;

        Goto(cx,cy);

        Delete_Line(cx);

        /* Delete_Line only decrements cursor_x if we're on last line of
           document!  That means we have to if we're not. */

        if (offset+cx <= num_lines && cursor_x+offset != 1)
          cursor_x--;

        if (strlen(screen[offset+cursor_x]+1) >= usrwidth)
        {
          cx=cursor_x;

          Goto(cx=cursor_x,cursor_y=usrwidth);

          Word_Wrap(MODE_UPDATE);

          cursor_x=cx;

          if (cy >= strlen(screen[offset+cursor_x]+1))  /* If we didn't get anywhere */
          {
            cursor_x++;
            cy=1;
          }
        }

        Goto(cursor_x,cursor_y=cy);
      }
    }
  }

  Update_Position();
}



void pascal Delete_Char(void)
{
  byte save_cr;
  int cx,cy;

  if (! (cursor_y > strlen(screen[offset+cursor_x]+1)))
  {
    if (strlen(screen[offset+cursor_x]+1) != 0)
    {
      memmove(screen[offset+cursor_x]+cursor_y,screen[offset+cursor_x]+cursor_y+1,
              strlen(screen[offset+cursor_x]+cursor_y+1)+1);

      Update_Line(offset+cursor_x,cursor_y,0,TRUE);
    }
  }
  else    /* At end of line, join! */
  {
    if (offset+cursor_x != num_lines && cursor_y != usrwidth)
    {
      if (cursor_y > (strlen(screen[offset+cursor_x]+1)+1))
      {
        memset(screen[offset+cursor_x]+strlen(screen[offset+cursor_x]+1)+1,' ',cursor_y-strlen(screen[offset+cursor_x]));
        screen[offset+cursor_x][cursor_y]='\0';
      }

      memmove(screen[offset+cursor_x]+cursor_y,screen[offset+cursor_x+1]+1,
              strlen(screen[offset+cursor_x+1]+1)+1);

      save_cr=*screen[offset+cursor_x+1];
      Delete_Line(cursor_x+1);

      if (strlen(screen[offset+cursor_x]+1) >= usrwidth)
      {
        if (save_cr==HARD_CR)
          *screen[offset+cursor_x]=save_cr;
            
        cx=cursor_x;
        cy=cursor_y;

        Goto(cx=cursor_x,cursor_y=usrwidth);

        Word_Wrap(MODE_UPDATE);

        Goto(cursor_x=cx,cursor_y=cy);
      }

      Update_Line(offset+cursor_x,cursor_y,0,TRUE);

      Update_Position();
    }
  }
}


void pascal Add_Character(int ch)
{
  int cx,cy,
      oldoffset,
      x;

  if (cursor_y==usrwidth)
  {
    cy=cursor_y;
    x=Word_Wrap(MODE_SCROLL);            /* Scroll if necessary */
    cursor_y=(cy-x)+1;
  }

  if (cursor_y > (strlen(screen[offset+cursor_x]+1)+1))
  {
    memset(screen[offset+cursor_x]+strlen(screen[offset+cursor_x]+1)+1,' ',cursor_y-strlen(screen[offset+cursor_x]));
    screen[offset+cursor_x][cursor_y]='\0';
  }

  if (insert || screen[offset+cursor_x][cursor_y]=='\0') /* If insert mode or we're in last column */
  {
    Insert_At(cursor_x,cursor_y,(char)ch,1);

    if (screen[offset+cursor_x][cursor_y]=='\0')
      Putc(ch);

    if (strlen(screen[offset+cursor_x]+1) >= usrwidth)
    {
      cx=cursor_x;
      cy=cursor_y;
      oldoffset=offset;

      cursor_y=usrwidth;

      Goto(cx,cursor_y);

      x=Word_Wrap(MODE_UPDATE);
      
      if (cursor_x >= usrlen)
        Scroll_Down(SCROLL_LINES,cursor_x-SCROLL_LINES);

      if (cy > strlen(screen[oldoffset+cx]+1))
      {
/*      Goto(cursor_x,cursor_y -= (usrwidth-cy)+(x < cy ? 1 : 0)); */
        
        if (cy-x+1 >= 1 && cy-x+1 <= usrwidth);
          Goto(cursor_x,cursor_y=cy-x+1);
      }
      else
      {
        Goto(cursor_x=cx-(offset-oldoffset),cursor_y=cy);
      }
    }
  }
  else
  {
    screen[offset+cursor_x][cursor_y++]=(char)ch;
    Putc(ch);
  }

  Update_Position();
}



void pascal Insert_At(int cx,int cy,char ch,int inc)
{
  memmove(screen[offset+cx]+cy+1,screen[offset+cx]+cy,
          strlen(screen[offset+cx]+cy)+1);

  screen[offset+cx][cy]=ch;

  screen[offset+cx][usrwidth+1]='\0';

  if (screen[offset+cx][cy+1] != '\0')
    Update_Line(offset+cursor_x,cursor_y,inc,TRUE);

  cursor_y += inc;
}


void pascal Update_Line(int cx,int cy,int inc,int update_cursor)
{
  /* Only update lines which are on-screen! */
  if (cx > offset && cx < offset+usrlen)
  {
    if (!Mdm_keyp() || cx==cursor_x+offset)
    {
      /* If we have to save and move */

      if (cx-offset != cursor_x || cy != cursor_y)   
        Goto(cx-offset,cy);

      if (cx != max_lines)
      {
        if (cx > max_lines || screen[cx]==NULL || (cx <= num_lines && screen[cx][cy]=='\0' && screen[cx][1]))
        {
/*          Putc(' '); */
        }
        else Printf("%0.*s",usrwidth-cy,screen[cx]+cy);
      }
      else Printf(s(end_widget),DEFAULT_ATTR);

      if (cx >= max_lines || screen[cx]==NULL ||
          (cy+strlen(screen[cx]+cy) <= usrwidth))
        Puts(CLEOL);

      if (update_cursor)
        Goto(cx-offset,cy+inc);

      if ((int)update_table[cx] >= cy)
        update_table[cx]=FALSE;
    }
    else update_table[cx]=TRUE;
  }
}


/* Sends us to a new virtual line, no matter what!  Doesn't do             *
 * word-wrapping, splitting, etc.                                          */

void pascal New_Line(int col)
{                         
  int x;

  if (cursor_x+offset+1 < max_lines)
  {
    cursor_x++;
    cursor_y=(col==0 ? 1 : col);

    if (cursor_x+offset > num_lines)
    {
      for (x=num_lines+1;x <= cursor_x+offset;x++)
      {
        if (Allocate_Line(x))
          EdMemOvfl();
      }
    }
  }
}



void pascal Carriage_Return(int hard)
{
  int cx,
      temp,
      added_line,
      x;
    
  byte save_cr;

  added_line=FALSE;

  if (cursor_x+1 >= usrlen)
    Scroll_Down(SCROLL_LINES,cursor_x-SCROLL_LINES);

  cx=cursor_x+1;

  /* If we're on last line of message, allocate enough lines to fill to end */
  
  if (cx+offset+1 >= num_lines && (num_lines < max_lines-1))
  {
    /* For each one until num_lines+1, allocate a line */
    
    for (x=num_lines+1;x <= cx+offset;x++)
    {
      added_line=TRUE;

      if (Allocate_Line(x))
        EdMemOvfl();
    }
  }

  temp=1;

  /* If we need to insert a line in the middle, and there's enough room */
  
  if (insert && num_lines < max_lines-1)
  {
    save_cr=*screen[offset+cursor_x];
    
    /* If we're supposed to do a hard C/R, then do so */

    if (hard)
      *screen[offset+cursor_x]=HARD_CR;

    if (! (cx+offset > num_lines) && !added_line)
    {
      if (Allocate_Line(num_lines+1))
        EdMemOvfl();
    }

    if (cursor_y < usrwidth)
      Puts(CLEOL);

    if ((temp=Insert_Line_Before_CR(cx)) != 0)
    {
      /* If we need to split this line in two... */
      if (cursor_y <= strlen(screen[offset+cursor_x]+1))
        memmove(screen[offset+cx]+1,screen[offset+cursor_x]+cursor_y,
                strlen(screen[offset+cursor_x]+cursor_y)+1);
      else screen[offset+cx][1]='\0'; /* else blank out the next line */

      /* Copy the attribute to the next line */
      *screen[offset+cx]=save_cr;

      /* Chop off this line, where we split it. */
      screen[offset+cursor_x][cursor_y]='\0';

      Update_Line(offset+cx,1,0,FALSE);
    }
  }

  if (temp && offset+cursor_x != max_lines-1)
  {
/*  screen[offset+cx][0]=HARD_CR; */

    Goto(++cursor_x,cursor_y=1);

    Update_Position();
  }
}


int pascal Insert_Line_Before_CR(int cx)
{
  int x;
  char *p;

  if (num_lines < max_lines)
  {
    if (screen[num_lines][1] != '\0')
    {
      if (Allocate_Line(num_lines+1))
        EdMemOvfl();
    }

    p=screen[num_lines];

    for (x=min(num_lines-1,max_lines-1);x >= offset+cx;x--)
    {
      screen[x+1]=screen[x];
      update_table[x+1]=TRUE;

/*    screen[x+1][0]=screen[x][0];
      memmove(screen[x+1]+1,screen[x]+1,strlen(screen[x]+1)+1);
      update_table[x+1]=TRUE; */
    }

    screen[offset+cx]=p;

    return 1;
  }
  else
  {
    Goto(cursor_x,cursor_y=1);
    return 0;
  }
}



int pascal Insert_Line_Before(int cx)
{
  int x;
  char *p;

  if (num_lines < max_lines-1)
  {
    if (screen[num_lines][1] != '\0')
    {
      if (Allocate_Line(num_lines+1))
        EdMemOvfl();
    }

    p=screen[num_lines];

    for (x=min(num_lines-1,max_lines-1);x >= offset+cx;x--)
    {
      screen[x+1]=screen[x];
      update_table[x+1]=TRUE;

/*    screen[x+1][0]=screen[x][0];
      memmove(screen[x+1]+1,screen[x]+1,strlen(screen[x]+1)+1);

      update_table[x+1]=TRUE; */
    }

    screen[offset+cx]=p;

    return 1;
  }
  else
  {
    Goto(cursor_x,cursor_y=1);
    return 0;
  }
}


void pascal Delete_Line(int cx)
{
  int x;
  char *p;

  if (num_lines != 1)
  {
    p=screen[cx+offset];

    for (x=cx+offset;x < num_lines;x++)
    {
      screen[x]=screen[x+1];
      update_table[x]=TRUE;

/*    screen[x][0]=screen[x+1][0];
      memmove(screen[x]+1,screen[x+1]+1,strlen(screen[x+1]+1)+1);

      update_table[x]=TRUE; */
    }

    screen[num_lines]=p;

/*  screen[num_lines][1]='\0'; */
    update_table[num_lines]=TRUE;

    Free_Line(num_lines);

    if (cursor_x+offset > num_lines)  /* If we were on the very last line */
    {
      if (cursor_x==1 && offset != 0)
        Scroll_Up(SCROLL_CASUAL,cursor_x+SCROLL_CASUAL);
      
      cursor_x=num_lines-offset;
      cursor_y=1;
      Update_Position();
    }

    Goto(cursor_x,cursor_y);
  }
  else             /* We're on the first line, so just erase it! */
  {
    Goto(cursor_x,cursor_y=1);
    Puts(CLEOL);
    screen[offset+cursor_x][cursor_y]='\0';
  }
}



int pascal Word_Wrap(int mode)
{
  int cx,cy,x,y;
  char zerolen;

  
  /* Get over any ending whitespace on this line */
  for (x=usrwidth;is_wd(screen[offset+cursor_x][x]);x--)
    ;

  for (;x > usrwidth-MAX_WRAPLEN;x--) /* Now find the beginning of the word */
  {
    if (is_wd(screen[offset+cursor_x][x]))  /* Found it! */
    {
      /* 'x' used to point to the whitespace; we want it to point to the    *
       * start of the word.                                                 */
      
      x++;

      /* Put the cursor here, unless we're told not to move it */
      
      if (mode != MODE_NOUPDATE)
        Goto(cursor_x,cursor_y-(usrwidth-x));

      /* Update virtual cursor position to reflect placement of new word */
      
      if ((cursor_y -= (usrwidth-x)) < 1)
        cursor_y=1;

      cx=cursor_x+1;

      /* If we need to allocate any more lines at the end, then do so. */
      
      if (offset+cx > num_lines && offset+cx < max_lines)
      {
        for (y=num_lines+1;y <= cx+offset;y++)
        {
          if (Allocate_Line(y))
            EdMemOvfl();
        }
      }
      else if (offset+cx==max_lines ||
               (/*(! isalnum(screen[offset+cx][1]) ||
                 screen[offset+cx][1]=='\0') && */
                screen[offset+cursor_x][0]==HARD_CR))
      {
        /* else we're trying to insert a line in the middle of the text,   *
         * so plop it in the right spot.                                   */
        
        if (! Insert_Line_Before(cx)) /* If we can't insert (end of text?) */
        {
          screen[offset+cx][x]='\0';
          Update_Line(offset+cx,1,0,TRUE);
          return x;
        }
      }

      /* Now state that we've wordwrapped */
      screen[offset+cursor_x][0]=SOFT_CR;

      /* If there's something on the next line to wrap... */
      if (screen[offset+cx][1])
      {
        /* Move line over, to make room for new word */
        memmove(screen[offset+cx]+1+strlen(screen[offset+cursor_x]+x),
                screen[offset+cx]+1,
                strlen(screen[offset+cx]+1)+1);

              
        /* Put new word in place */
        memmove(screen[offset+cx]+1,screen[offset+cursor_x]+x,
                y=strlen(screen[offset+cursor_x]+x));

        /* Remove the first word from the prior line */
        screen[offset+cursor_x][x]='\0';

        /* Display that on-screen */
        if (cursor_y < usrwidth && mode != MODE_NOUPDATE)
          Puts(CLEOL);

        /* If this causes a scroll, then do so */
        if ((mode==MODE_SCROLL /*|| mode==MODE_UPDATE*/) &&
            (cursor_x+1 >= usrlen))
          Scroll_Down(SCROLL_LINES,cursor_x-SCROLL_LINES);

        /* If the word we just moved was zero-length */
        if (y==0 || (x <= strlen(screen[offset+cursor_x]+1)+1 &&
                     !is_wd(*(screen[offset+cursor_x]+x)) &&
                     screen[offset+cx][1]))
          zerolen=TRUE;
        else zerolen=FALSE;

        /* Go to a new line. */
        New_Line(y);
      }
      else /* else there's nothing on the next line, so just copy */
      {
        memmove(screen[offset+cx]+1,screen[offset+cursor_x]+x,
                y=strlen(screen[offset+cursor_x]+x)+1);

        /* Get rid of the original word */
        screen[offset+cursor_x][x]='\0';

        /* ...and show the deletion on-screen. */
        if (cursor_y < usrwidth)
          Puts(CLEOL);

        /* Scroll, if necessary */
        
        if ((mode==MODE_SCROLL /*|| mode==MODE_UPDATE*/) &&
            (cursor_x+1 >= usrlen))
        {
          Scroll_Down(SCROLL_LINES,cursor_x-SCROLL_LINES);
          cx=cursor_x;
        }

        /* Go to a new line */
        New_Line(--y);

        /* ...and set a flag, based on the length of this word */
        if (y==0)
          zerolen=TRUE;
        else zerolen=FALSE;
      }

      /* If this has caused the *current* line to be in need of a wrap... */
      if (strlen(screen[offset+cursor_x]+1) >= usrwidth)
      {
        /* Dummy up the cursor position accordingly */
        cy=cursor_y;
        cx=cursor_x;
        cursor_y=usrwidth;

        /* And make a recursive call to ourselves */
        Word_Wrap(MODE_NOUPDATE);

        /* Fix cursor position back to where we were */
        cursor_x=cx;
        cursor_y=cy+1;
      }
      
      /* Put cursor in final spot */
      if (cx < usr.len)
        Goto(cx,cursor_y);

      /* Indicate that this line was updated */
      update_table[offset+cursor_x]=TRUE;

      /* And move cursor appropriately. */
      if (! zerolen)
        cursor_y++;
      break;
    }
  }

  /* If the word was the maximum length allowable */
  if (x==usrwidth-MAX_WRAPLEN)
  {
    /* Chop off anything */
    screen[offset+cursor_x][usrwidth]='\0';
    Carriage_Return(FALSE);
  }

  /* If this is the last recursive call, then update our position */
  if (mode==MODE_UPDATE || mode==MODE_SCROLL)
    Update_Position();

  return x;
}


void pascal Cursor_Left(void)
{
  if (cursor_y > 1)
  {
    Puts(LEFT);
    cursor_y--;
    Update_Position();
  }
}

void pascal Cursor_Right(void)
{
  if (cursor_y < usrwidth)
  {
    Puts(RIGHT);
    cursor_y++;
    Update_Position();
  }
}

void pascal Cursor_Up(void)
{
  if (offset+cursor_x > 1)
  {
    if (cursor_x==1 && offset != 0)
      Scroll_Up(SCROLL_CASUAL,cursor_x+SCROLL_CASUAL);

    Puts(UP);
    cursor_x--;
    Update_Position();
  }
}


void pascal Cursor_Down(int update_pos)
{
  if (cursor_x+offset < num_lines)
  {
    if (cursor_x+1 >= usrlen)
      Scroll_Down(SCROLL_CASUAL,cursor_x-SCROLL_CASUAL);

    cursor_x++;

    if (update_pos)
    {
      Puts(DOWN);
      Update_Position();
    }
  }
}

void pascal Cursor_BeginLine(void)
{
  Goto(cursor_x,cursor_y=1);
  Update_Position();
}

void pascal Cursor_EndLine(void)
{
  Goto(cursor_x,cursor_y=strlen(screen[offset+cursor_x]+1)+1);
  Update_Position();
}

void pascal Toggle_Insert(void)
{
  insert=(char)!insert;

  Goto(usrlen,usrwidth-13);

  Puts(insert ? status_insert : s(insrt_ovrwrt));

  Goto(cursor_x,cursor_y);
  Printf(attr_string,DEFAULT_ATTR);
}

void pascal Update_Position(void)
{
#ifdef UPDATE_POSITION
  if (! Mdm_keyp() && !skip_update)
  {
    pos_to_be_updated=FALSE;

    Goto(usrlen,70);
    Printf("%u:%u  ",offset+cursor_x,cursor_y);
    Goto(cursor_x,cursor_y);
  }
  else pos_to_be_updated=TRUE;
#endif

#ifdef OS_2
  if (displaymode==VIDEO_ibm)
    Vidfcur();
#endif
}




void pascal Word_Left(void)
{
  int cx=cursor_x,
      cy=cursor_y;

  if (cy > 2)
    cy--;

  if (! isalnumpunct(screen[offset+cx][cy]) || ! isalnumpunct(screen[offset+cx][cy-1]) || cy==1 ||
      cy > strlen(screen[offset+cx]+1))
  {
    while (((! isalnumpunct(screen[offset+cx][cy])) || cy > strlen(screen[offset+cx]+1)) &&
           cy > 1)
      cy--;

    if (cy==1 && (isalnumpunct(screen[offset+cx][1]) ?
                  ((isalnumpunct(screen[offset+cx][2]) || cursor_y==1)) :
                  TRUE))
      Up_a_Line(&cx,&cy);
    else
    {
      while (isalnumpunct(screen[offset+cx][cy]) && cy > 1)
        cy--;

      if ((cy==1 && ! isalnumpunct(screen[offset+cx][1])) || cy > 1)
        cy++;
    }
  }
  else
  {
    while ((isalnumpunct(screen[offset+cx][cy])) && cy > 1)
      cy--;

    if ((cy==1 && ! isalnumpunct(screen[offset+cx][1])) || cy > 1)
      cy++;
  }

  if (cx != cursor_x || cy != cursor_y)
  {
    cursor_x=cx;
    cursor_y=cy;

    if (cursor_x <= 0 && offset != 0)
      Scroll_Up(SCROLL_CASUAL,cursor_x+SCROLL_CASUAL);

    Goto(cursor_x,cursor_y);
    Update_Position();
  }
}


void pascal Word_Right(void)
{
  int cx=cursor_x,
      cy=cursor_y;

  if (isalnumpunct(screen[offset+cx][cy]) || isalnumpunct(screen[offset+cx][cy-1]) || cy==1 ||
      cy > strlen(screen[offset+cx]+1))
  {
    while (((isalnumpunct(screen[offset+cx][cy])) && cy <= strlen(screen[offset+cx]+1)) &&
           cy < usrwidth)
      cy++;

    if (cy >= strlen(screen[offset+cx]+1) && cy <= cursor_y)
      Down_a_Line(&cx,&cy);
    else while (! isalnumpunct(screen[offset+cx][cy]) &&
                screen[offset+cx][cy] && cy < usrwidth)
      cy++;
  }
  else while ((! isalnumpunct(screen[offset+cx][cy])) && cy < usrwidth)
      cy++;

  if (cx != cursor_x || cy != cursor_y)
  {
    cursor_x=cx;
    cursor_y=cy;

    if (cursor_x >= usrlen)
      Scroll_Down(SCROLL_CASUAL,cursor_x-SCROLL_CASUAL);

    Goto(cursor_x,cursor_y);
    Update_Position();
  }
}


void pascal Up_a_Line(int *cx,int *cy)
{
  if ((*cx)+offset != 1)
  {
    *cx=*cx-1;
    *cy=strlen(screen[offset+(*cx)]+1)+1;
  }
  else *cy=1;
}

void pascal Down_a_Line(int *cx,int *cy)
{
  if (*cx+offset != num_lines)
  {
    *cx=*cx+1;

    for (*cy=1;screen[offset+*cx][*cy];(*cy)++)
      if (isalnumpunct(screen[offset+*cx][*cy]))
        break;
  }
  else *cy=strlen(screen[offset+*cx]+1)+1;
}


void pascal Scroll_Up(int n,int location)
{
  if (offset-n >= 0)
    offset -= n;
  else offset=0;

  cursor_x=location;
  Redraw_Text();
}


void pascal Scroll_Down(int n,int location)
{
  if (offset+n >= num_lines)
  {
    offset=num_lines;
    location=1;
  }
  else offset += n;

  cursor_x=location;
  Redraw_Text();
}

void pascal Page_Up(void)
{
  if (quoting)
    Quote_Up();
  else
  {
    if (offset==0)
    {
      Goto(cursor_x=1,cursor_y);
    }
    else Scroll_Up(usrlen-1,cursor_x);

    Update_Position();
  }
}

void pascal Page_Down(void)
{
  if (quoting)
    Quote_Down();
  else
  {
    if (offset+usrlen > num_lines)
      Goto(cursor_x=num_lines-offset,cursor_y);
    else
    {
      offset += usrlen-1;

      if (offset > num_lines)
        offset=num_lines-1;

      if (offset+cursor_x > num_lines)
        cursor_x=num_lines-offset;

      Redraw_Text();
    }

    Update_Position();
  }
}




void pascal NoFF_CLS()
{
  Goto(1,1);
  Printf("\x16\x19\x03" CLEOL "\n%c",usr.len-(usr.help==HOTFLASH ? 1 : 0));
  Goto(1,1);
}

void pascal Fix_MagnEt(void)
{
  if (usr.formfeed)
    Puts(CLS);
  else NoFF_CLS();

  Redraw_Text();
  Redraw_StatusLine();
  Redraw_Quote();

  (void)mdm_ctrlc(0);
  Mdm_Flow_Off();
}

static void pascal Do_Update(void)
{
  int x,y,
      updated;

  updated=FALSE;

  y=min(offset+usrlen+1,UPDATEBUF_LEN-1);

  for (x=offset;x <= y && ! Mdm_keyp();x++)
    if (update_table[x])
    {
      if (updated && offset+cursor_x==x)
        Goto(cursor_x,cursor_y);

      Update_Line(x,1,0,FALSE);
      updated=TRUE;
    }

  if (updated)
    Goto(cursor_x,cursor_y);
}

void pascal Init_Vars(void)
{
  int x;
  struct _fossil_info finfo;

  offset=0;
  num_lines=offset;
  cursor_x=cursor_y=1;
  quoting=pos_to_be_updated=skip_update=FALSE;
  insert=update_table[max_lines]=TRUE;

  usrwidth=min(LINELEN,usr.width);

  /* Make sure that the user's screen is never larger than the Sysop's,    *
   * to avoid problems.                                                    */

  fossil_inf((struct _fossil_info far *)&finfo);
  usrlen=min(usr.len,finfo.height-((prm.flags & FLAG_statusline) ? 1 : 0))-(usr.help==HOTFLASH ? 1 : 0);

  for (x=0;x < max_lines;x++)
    update_table[x]=FALSE;
}


void pascal MagnEt_Intro(void)
{
  Goto(usrlen,1);

  Printf(YELONBLUE CLEOL "%s v%4.4s    %s",magnEt,version,ck_for_help);

  Goto(cursor_x,cursor_y);

  while (! Mdm_keyp())
    Giveaway_Slice();

  Redraw_StatusLine();
}


void pascal Quote_OnOff(void)
{
  char temp[PATHLEN];

  struct _msg msg;

  /* Null out attribute for line in quoted message */
  last_msg_attr=0;

  if (isareply)
  {
    if (quoting)  /* If we were already quoting */
    {
      quoting=FALSE;
      close(quotefile);
      usrlen += QUOTELINES;

      quotefile=-1;

      Fix_MagnEt();
    }
    else
    {
      sprintf(temp,d_msg,last_msg);

      if ((quotefile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
      {
        /* Throw away msg. header */
        read(quotefile,(char *)&msg,sizeof(struct _msg));

        Parse_Initials(msg.from,initials);

        quoting=TRUE;
        usrlen -= QUOTELINES;

        if (cursor_x > usrlen)
        {
          offset += (cursor_x-usrlen)+1;
          cursor_x=usrlen-1;
        }

        if (usr.formfeed)
          Puts(CLS);
        else NoFF_CLS();

        Redraw_Text();
        Redraw_StatusLine();

        cur_quotebuf=-1;
        num_quotebuf=0;
        last_quote=0x7fff;
        quote_pos[0]=(long)sizeof(struct _msg);

        Quote_Down();           /* Read the 1st four lines into window */
      }
    }
  }
  else
  {
    Goto(usrlen,1);
    Puts(s(max_not_reply));
    Goto(cursor_x,cursor_y);

    while (! Mdm_keyp())
      Giveaway_Slice();

    Redraw_StatusLine();
  }
}



void pascal Quote_Up()
{
  char temp[PATHLEN];

  if (cur_quotebuf >= 1 && cur_quotebuf < MAX_QUOTEBUF)
  {
    last_msg_attr=MSGLINE_normal;

    sprintf(temp,d_msg,last_msg);

    cur_quotebuf--;
    Quote_Read();
  }
}

void pascal Quote_Down(void)
{
  last_msg_attr=MSGLINE_normal;

  if (cur_quotebuf < last_quote)
  {
    cur_quotebuf++;

    if (num_quotebuf < MAX_QUOTEBUF && cur_quotebuf >= num_quotebuf)
      quote_pos[num_quotebuf++]=tell(quotefile);

    if (Quote_Read())
      last_quote=cur_quotebuf;
  }
}

int pascal Quote_Read(void)
{
  char linetype[QUOTELINES],
       *p[4],
       *s2;

  int temp,
      qbl,
      done,
      lines_displayed,
      x;

  lines_displayed=0;

  done=FALSE;

  if (cur_quotebuf < MAX_QUOTEBUF)
    lseek(quotefile,quote_pos[cur_quotebuf],SEEK_SET);

  while (lines_displayed < QUOTELINES)
  {
    for (x=0;x < 4;x++)
      p[x]=quotebuf+((lines_displayed+x)*MAX_LINELEN);

    qbl=Msg_Read_Lines(quotefile,
                       QUOTELINES-lines_displayed,
                       usrwidth-strlen(initials)-4,
                       p,
                       linetype+lines_displayed,
                       &last_msg_attr);

    if (qbl != QUOTELINES-lines_displayed)
      done=TRUE;

    if (lines_displayed==0)
      for (temp=qbl;temp < QUOTELINES;temp++)
        mknl(quotebuf+(qbl*MAX_LINELEN));


    for (temp=lines_displayed;temp < QUOTELINES;temp++)
    {
      s2=quotebuf+(temp*MAX_LINELEN);

      if (linetype[temp] & MSGLINE_seenby &&
          !GEPriv(usr.priv,prm.seenby_priv))
        continue;
      else if (linetype[temp] & MSGLINE_kludge &&
               !GEPriv(usr.priv,prm.ctla_priv))
        continue;
      else if (linetype[temp] & MSGLINE_end)
        strcpy(s2,s(end_widget2));

      Printf(quote_format,usrlen+1+lines_displayed,initials,s2);

      if (temp > lines_displayed)
        strcpy(quotebuf+(lines_displayed*MAX_LINELEN),s2);

      lines_displayed++;

      if (linetype[temp] & MSGLINE_end)
      {
        while (lines_displayed < QUOTELINES)
          Printf(quote_format,usrlen+1+lines_displayed++,initials,blank_str);

        goto EndQuote;
      }
    }
  }

EndQuote:

  Puts(CYAN);
  Goto(cursor_x,cursor_y);  /* Restore original cursor position */

  return done;
}

void pascal Parse_Initials(char *msgfrom,char *initials)
{
  char *p,
       *s,
       os[36];


  strncpy(os,msgfrom,35);
  msgfrom[35]='\0';

  /* Copy the user's initials into the string initials[]. */

  p=strtok(os,ctl_delim);

  for (s=initials;p && s < initials+9;p=strtok(NULL,ctl_delim))
    *s++=*p;

  *s='\0';
}


